#include "typedef.h"

#include <stdio.h>

#include "util.h"
#include "object.h"
#include "edge.h"

Cedge		*Cedge::g_hash[HASHSIZE] = {0};

u4T
Cedge::hash(const Centity *fromP, const Centity *toP, u4T code)
{
	int		ret;

	ret = (((int) fromP) + ((int) toP) + code) >> 3;
	return(ret & (HASHSIZE-1));
}

Cedge::Cedge(Centity *fromP, Centity *toP, edgetypeE code, int lineno)
{
	unsigned int index;

	m_lineno = lineno;
	m_fromP  = fromP;
	m_toP    = toP;
	m_code   = code;
	m_freq   = 1;

	index = hash(fromP, toP, code);
	m_hashP       = g_hash[index];
	g_hash[index] = this;
	add_created();
}

void
Cedge::locate(Centity *fromP, Centity *toP, edgetypeE code, int lineno)
{
	extern int		g_hide_edges[NUMBER_EDGE_TYPES];

	Cedge 			*edgeP;
	unsigned int	index;

	if (!g_hide_edges[code]) {
		index = hash(fromP, toP, code);
		for (edgeP = g_hash[index]; edgeP; edgeP = edgeP->m_hashP) {
			if (edgeP->m_fromP == fromP && edgeP->m_toP == toP && edgeP->m_code == code) {
				edgeP->m_freq++;
				return;
		}	}
		edgeP = new Cedge(fromP, toP, code, lineno);
		if (!edgeP) {
			outofmemory();
	}	}
}

/* virtual */ objectE
Cedge::type(void) const
{
	return(edgeE);
}

const char *
Cedge::get_type(void) const
{
	static char	buffer[20];

	sprintf(buffer, "E%d", m_code);
	return(buffer);
}

/* virtual */ void
Cedge::emit_id(void) const
{
	fprintf(stdout, "E%d ", m_code);
	m_fromP->emit_id();
	fputc(' ', stdout);
	m_toP->emit_id();
}

void
Cedge::emit_edges(void)
{
	emit_id();
	fputc('\n', stdout);
}

void
Cedge::emit_attributes(void) const
{
	fputc('(', stdout);
	emit_id();
	fputs(") {file=.", stdout);

	if (m_lineno >= 0) {
		fprintf(stdout, " lineno=%d", m_lineno);
	}
	fprintf(stdout, " freq=%d}\n", m_freq);
}
